---
version: '3'
services:

  zookeeper:
    image: confluentinc/cp-zookeeper:latest
    ports:
      - "32181:32181"
    environment:
      ZOOKEEPER_CLIENT_PORT: 32181
      ZOOKEEPER_TICK_TIME: 2000
    extra_hosts:
      - "moby:127.0.0.1"

  kafka1:
    image: confluentinc/cp-kafka:latest
    ports:
      - "29092:29092"
      - "29093:29093"
    depends_on:
      - zookeeper
    environment:
      KAFKA_BROKER_ID: 1
      KAFKA_OFFSETS_TOPIC_REPLICATION_FACTOR: 1
      KAFKA_ZOOKEEPER_CONNECT: zookeeper:32181
      KAFKA_ADVERTISED_LISTENERS: PLAINTEXT://192.168.1.22:29092,SASL_PLAINTEXT://192.168.1.22:29093
      KAFKA_SECURITY_INTER_BROKER_PROTOCOL: PLAINTEXT
      KAFKA_SASL_MECHANISM_INTER_BROKER_PROTOCOL: PLAIN
      KAFKA_SASL_ENABLED_MECHANISMS: PLAIN,ANONYMOUS
      KAFKA_SUPER_USERS: User:admin
      KAFKA_ALLOW_EVERYONE_IF_NO_ACL_FOUND: "true"
      # See: https://github.com/confluentinc/cp-docker-images/blob/3.2.x/debian/base/include/cub#L99
      ZOOKEEPER_SASL_ENABLED: "false"
      KAFKA_AUTHORIZER_CLASS_NAME: kafka.security.auth.SimpleAclAuthorizer
      KAFKA_OPTS: -Djava.security.auth.login.config=/etc/kafka/custom/kafka_server_jaas.conf
    volumes:
      - ${KAFKA_SASL_DIR}:/etc/kafka/custom
    extra_hosts:
      - "moby:127.0.0.1"

  kafka2:
    image: confluentinc/cp-kafka:latest
    ports:
      - "29094:29094"
      - "29095:29095"
    depends_on:
      - zookeeper
    environment:
      KAFKA_BROKER_ID: 2
      KAFKA_OFFSETS_TOPIC_REPLICATION_FACTOR: 1
      KAFKA_ZOOKEEPER_CONNECT: zookeeper:32181
      KAFKA_ADVERTISED_LISTENERS: PLAINTEXT://192.168.1.22:29094,SASL_PLAINTEXT://192.168.1.22:29095
      KAFKA_SECURITY_INTER_BROKER_PROTOCOL: PLAINTEXT
      KAFKA_SASL_MECHANISM_INTER_BROKER_PROTOCOL: PLAIN
      KAFKA_SASL_ENABLED_MECHANISMS: PLAIN,ANONYMOUS
      KAFKA_SUPER_USERS: User:admin
      KAFKA_ALLOW_EVERYONE_IF_NO_ACL_FOUND: "true"
      # See: https://github.com/confluentinc/cp-docker-images/blob/3.2.x/debian/base/include/cub#L99
      ZOOKEEPER_SASL_ENABLED: "false"
      KAFKA_AUTHORIZER_CLASS_NAME: kafka.security.auth.SimpleAclAuthorizer
      KAFKA_OPTS: -Djava.security.auth.login.config=/etc/kafka/custom/kafka_server_jaas.conf
    volumes:
      - ${KAFKA_SASL_DIR}:/etc/kafka/custom
    extra_hosts:
      - "moby:127.0.0.1"

  kafka3:
    image: confluentinc/cp-kafka:latest
    ports:
      - "29096:29096"
      - "29097:29097"
    depends_on:
      - zookeeper
    environment:
      KAFKA_BROKER_ID: 3
      KAFKA_OFFSETS_TOPIC_REPLICATION_FACTOR: 1
      KAFKA_ZOOKEEPER_CONNECT: zookeeper:32181
      KAFKA_ADVERTISED_LISTENERS: PLAINTEXT://192.168.1.22:29096,SASL_PLAINTEXT://192.168.1.22:29097
      KAFKA_SECURITY_INTER_BROKER_PROTOCOL: PLAINTEXT
      KAFKA_SASL_MECHANISM_INTER_BROKER_PROTOCOL: PLAIN
      KAFKA_SASL_ENABLED_MECHANISMS: PLAIN,ANONYMOUS
      KAFKA_SUPER_USERS: User:admin
      KAFKA_ALLOW_EVERYONE_IF_NO_ACL_FOUND: "true"
      # See: https://github.com/confluentinc/cp-docker-images/blob/3.2.x/debian/base/include/cub#L99
      ZOOKEEPER_SASL_ENABLED: "false"
      KAFKA_AUTHORIZER_CLASS_NAME: kafka.security.auth.SimpleAclAuthorizer
      KAFKA_OPTS: -Djava.security.auth.login.config=/etc/kafka/custom/kafka_server_jaas.conf
    volumes:
      - ${KAFKA_SASL_DIR}:/etc/kafka/custom
    extra_hosts:
      - "moby:127.0.0.1"
